package jp.sf.beanbinder.validator.swing;

import java.awt.Color;
import java.awt.Component;
import java.awt.Window;

import javax.swing.JLabel;
import javax.swing.JMenuItem;
import javax.swing.JPopupMenu;
import javax.swing.text.JTextComponent;

import jp.sf.beanbinder.validator.ValidateDisplay;


public class SwingValidateDisplay implements ValidateDisplay {
    private Component component;
    
    public SwingValidateDisplay(JTextComponent component) {
        this.component = component;
    }
    public SwingValidateDisplay(JLabel component) {
        this.component = component;
    }
    public SwingValidateDisplay(Window component) {
        this.component = component;
    }
    public void update(String message) {
        if( this.component instanceof JTextComponent ) {
            ((JTextComponent)this.component).setText(message);
        }
        else if( this.component instanceof JLabel ) {
            ((JLabel)this.component).setText(message);
        }
        else if( this.component instanceof Window ) {
            if( message == null || message.length() <= 0 )return;
            JPopupMenu menu = new JPopupMenu();
            JMenuItem item = new JMenuItem(message);
            item.setForeground(Color.RED);
            menu.add(item);
            
            menu.show(this.component, 8, 25);
        }
    }
    
}
